//+-------------------------------------------------------------------------------+ 
//|                   jurik rbci bands divergence.mq4                             | 
//+-------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------+
//|                  Copyright  2011,http://www.forex-tsd.com                    |
//|       You are NOT ALLOWED to distribute this Indicator in any public forum    |
//|           Property of  http://www.forex-tsd.com ELITE section ONLY            |
//|                       WARNING, Use this Indicator at your risk                |
//|                                                                               |
//+-------------------------------------------------------------------------------+

#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     DeepSkyBlue
#property indicator_color2     SlateGray
#property indicator_color3     SlateGray
#property indicator_color4     SlateGray
#property indicator_color5     LimeGreen
#property indicator_color6     Red
#property indicator_width1     2
#property indicator_style2     STYLE_DASH
#property indicator_style3     STYLE_DASHDOTDOT
#property indicator_style4     STYLE_DASH
#property indicator_level1     0
#property indicator_levelcolor DarkOrchid

//
//
//
//
//

extern string TimeFrame                = "Current time frame";
extern int    RbciSmoothLength         = 5;
extern double RbciSmoothPhase          = 0;
extern bool   RbciSmoothDouble         = true;
extern int    VolatilityBandPeriod     = 34;
extern int    VolatilityBandMAMode     = MODE_LWMA;
extern double VolatilityBandMultiplier = 1.6185; 
extern bool   drawDivergences          = false;
extern bool   drawIndicatorTrendLines  = true;
extern bool   drawPriceTrendLines      = true;
extern color  colorBullishDivergence   = LimeGreen;
extern color  colorBearishDivergence   = Red;
extern string UniqueID                 = "rbcidivergebands";
extern bool   Interpolate              = true;

extern bool   alertsOn                 = true;
extern bool   alertsOnCurrent          = false;
extern bool   alertsMessage            = true;
extern bool   alertsSound              = false;
extern bool   alertsEmail              = false;

//
//
//
//
//

double rbci[];
double bandUp[];
double bandMiddle[];
double bandDown[];
double bullishDivergence[];
double bearishDivergence[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;
string shortName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
  IndicatorBuffers(7);
    SetIndexBuffer(0,rbci);
    SetIndexBuffer(1,bandUp);
    SetIndexBuffer(2,bandMiddle);
    SetIndexBuffer(3,bandDown);
    SetIndexBuffer(4,bullishDivergence); SetIndexStyle(4, DRAW_ARROW); SetIndexArrow(4, 233);
    SetIndexBuffer(5,bearishDivergence); SetIndexStyle(5, DRAW_ARROW); SetIndexArrow(5, 234);
    SetIndexBuffer(6,trend);
    
    //
    //
    //
    //
    //
         
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue");
      if (calculateValue)
      {
         int s = StringFind(UniqueID,":",0);
            shortName = UniqueID;
            UniqueID  = StringSubstr(UniqueID,0,s);
            return(0);
      }  
                
      timeFrame = stringToTimeFrame(TimeFrame);
      shortName = UniqueID+": "+timeFrameToString(timeFrame)+"  jurik rbci";

   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   int length = StringLen(UniqueID);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);  if(StringSubstr(name,0,length) == UniqueID)  ObjectDelete(name);   
   }
   return(0);
}

//
//
//
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rbci[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      for(i=limit; i>=0; i--)
      {
   
           double value1 = 0.1238169269451*Close[i]
                          +0.1221983501658*Close[i+1]
                          +0.1190011430108*Close[i+2]
                          +0.1143001746257*Close[i+3]
                          +0.1082083357775*Close[i+4]
                          +0.1008691117824*Close[i+5]
                          +0.0924544579826*Close[i+6]
                          +0.0831591882460*Close[i+7]
                          +0.0731968216651*Close[i+8]
                          +0.0627911325011*Close[i+9]
                          +0.0521720176304*Close[i+10]
                          +0.0415674676220*Close[i+11]
                          +0.03120052346999*Close[i+12]
                          +0.02127741353836*Close[i+13]
                          +0.01198981966718*Close[i+14]
                          +0.00350383519239*Close[i+15]
                          -0.00404130034650*Close[i+16]
                          -0.01053553119457*Close[i+17]
                          -0.01590136845728*Close[i+18]
                          -0.02009560547438*Close[i+19]
                          -0.02310598643001*Close[i+20]
                          -0.02495565070371*Close[i+21]
                          -0.02569543732024*Close[i+22]
                          -0.02540610735631*Close[i+23]
                          -0.02418933707968*Close[i+24]
                          -0.02217041377021*Close[i+25]
                          -0.01948743120540*Close[i+26]
                          -0.01629007442301*Close[i+27]
                          -0.01273209112891*Close[i+28]
                          -0.00897092800794*Close[i+29]
                          -0.00515330395028*Close[i+30]
                          -0.001424610881936*Close[i+31]
                          +0.002089714906396*Close[i+32]
                          +0.00527492988233*Close[i+33]
                          +0.00803981322228*Close[i+34]
                          +0.01031021336959*Close[i+35]
                          +0.01203833709278*Close[i+36]
                          +0.01319390261994*Close[i+37]
                          +0.01377360958119*Close[i+38]
                          +0.01379122900470*Close[i+39]
                          +0.01328501259881*Close[i+40]
                          +0.01230273314848*Close[i+41]
                          +0.01091362242228*Close[i+42]
                          +0.00919300646953*Close[i+43]
                          +0.00722551890827*Close[i+44]
                          +0.00509973699629*Close[i+45]
                          +0.002906438043441*Close[i+46]
                          +0.000729911949400*Close[i+47]
                          -0.001346036589003*Close[i+48]
                          -0.00325210803091*Close[i+49]
                          -0.00492308867006*Close[i+50]
                          -0.00631171934917*Close[i+51]
                          -0.00737835671608*Close[i+52]
                          -0.00810443966122*Close[i+53]
                          -0.00847884560573*Close[i+54]
                          -0.00850814309603*Close[i+55]
                          -0.00820791786681*Close[i+56]
                          -0.00761322935395*Close[i+57]
                          -0.00675617201370*Close[i+58]
                          -0.00569105890365*Close[i+59]
                          -0.00446463210704*Close[i+60]
                          -0.003136445450683*Close[i+61]
                          -0.001759234808441*Close[i+62]
                          -0.000391899232101*Close[i+63]
                          +0.000916713292996*Close[i+64]
                          +0.002115501258662*Close[i+65]
                          +0.00316846373575*Close[i+66]
                          +0.00404050173851*Close[i+67]
                          +0.00471194761689*Close[i+68]
                          +0.00516189438300*Close[i+69]
                          +0.00539023783301*Close[i+70]
                          +0.00540028907392*Close[i+71]
                          +0.00520072700713*Close[i+72]
                          +0.00481262249830*Close[i+73]
                          +0.00426189211234*Close[i+74]
                          +0.00357578092340*Close[i+75]
                          +0.002792791011630*Close[i+76]
                          +0.001945190969686*Close[i+77]
                          +0.001074072336198*Close[i+78]
                          +0.0002102221385011*Close[i+79]
                          -0.000610258489301*Close[i+80]
                          -0.001362909162372*Close[i+81]
                          -0.002016921408291*Close[i+82]
                          -0.002553050522480*Close[i+83]
                          -0.002955099512448*Close[i+84]
                          -0.00322723217731*Close[i+85]
                          -0.00334694099100*Close[i+86]
                          -0.00333535479504*Close[i+87]
                          -0.00319005665285*Close[i+88]
                          -0.002930348894442*Close[i+89]
                          -0.002568261433140*Close[i+90]
                          -0.002127236248681*Close[i+91]
                          -0.001623259096604*Close[i+92]
                          -0.001082462836013*Close[i+93]
                          -0.000522606151926*Close[i+94]
                          +0.00002812805821277*Close[i+95]
                          +0.000550592842051*Close[i+96]
                          +0.001019101013467*Close[i+97]
                          +0.001432459831088*Close[i+98]
                          +0.001802313902175*Close[i+99]
                          +0.002066320467808*Close[i+100]
                          +0.002267449265120*Close[i+101]
                          +0.002390634801585*Close[i+102]
                          +0.002440016443207*Close[i+103]
                          +0.002428710369870*Close[i+104]
                          +0.002363019645587*Close[i+105]
                          +0.002261631402824*Close[i+106]
                          +0.002135750325722*Close[i+107]
                          +0.002007788917687*Close[i+108]
                          +0.001891663701696*Close[i+109]
                          +0.001811330494697*Close[i+110]
                          +0.001782108479675*Close[i+111]
                          +0.001828472108508*Close[i+112]
                          -0.00923028648226*Close[i+113];

           //
           //
           //
           //
           //
           
           double value2 = 0.0982862174*Close[i+0] 
                          +0.0975682269*Close[i+1] 
                          +0.0961401078*Close[i+2] 
                          +0.0940230544*Close[i+3] 
                          +0.0912437090*Close[i+4] 
                          +0.0878391006*Close[i+5] 
                          +0.0838544303*Close[i+6] 
                          +0.0793406350*Close[i+7] 
                          +0.0743569346*Close[i+8] 
                          +0.0689666682*Close[i+9] 
                          +0.0632381578*Close[i+10] 
                          +0.0572428925*Close[i+11] 
                          +0.0510534242*Close[i+12] 
                          +0.0447468229*Close[i+13] 
                          +0.0383959950*Close[i+14] 
                          +0.0320735368*Close[i+15] 
                          +0.0258537721*Close[i+16] 
                          +0.0198005183*Close[i+17] 
                          +0.0139807863*Close[i+18] 
                          +0.0084512448*Close[i+19] 
                          +0.0032639979*Close[i+20] 
                          -0.0015350359*Close[i+21] 
                          -0.0059060082*Close[i+22] 
                          -0.0098190256*Close[i+23] 
                          -0.0132507215*Close[i+24] 
                          -0.0161875265*Close[i+25] 
                          -0.0186164872*Close[i+26] 
                          -0.0205446727*Close[i+27] 
                          -0.0219739146*Close[i+28] 
                          -0.0229204861*Close[i+29] 
                          -0.0234080863*Close[i+30] 
                          -0.0234566315*Close[i+31] 
                          -0.0231017777*Close[i+32] 
                          -0.0223796900*Close[i+33] 
                          -0.0213300463*Close[i+34] 
                          -0.0199924534*Close[i+35] 
                          -0.0184126992*Close[i+36] 
                          -0.0166377699*Close[i+37] 
                          -0.0147139428*Close[i+38] 
                          -0.0126796776*Close[i+39] 
                          -0.0105938331*Close[i+40] 
                          -0.0084736770*Close[i+41] 
                          -0.0063841850*Close[i+42] 
                          -0.0043466731*Close[i+43] 
                          -0.0023956944*Close[i+44] 
                          -0.0005535180*Close[i+45] 
                          +0.0011421469*Close[i+46] 
                          +0.0026845693*Close[i+47] 
                          +0.0040471369*Close[i+48] 
                          +0.0052380201*Close[i+49] 
                          +0.0062194591*Close[i+50] 
                          +0.0070340085*Close[i+51] 
                          +0.0076266453*Close[i+52] 
                          +0.0080376628*Close[i+53] 
                          +0.0083037666*Close[i+54] 
                          +0.0083694798*Close[i+55] 
                          +0.0082901022*Close[i+56] 
                          +0.0080741359*Close[i+57] 
                          +0.0077543820*Close[i+58] 
                          +0.0073260526*Close[i+59] 
                          +0.0068163569*Close[i+60] 
                          +0.0062325477*Close[i+61] 
                          +0.0056078229*Close[i+62] 
                          +0.0049516078*Close[i+63] 
                          +0.0161380976*Close[i+64];

                          rbci[i] = iDSmooth(value1-value2,RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,i,0);
                          }            
                          
                          //
                          //
                          //
                          //
                          //
                          
                          for(i=limit; i>=0; i--)
                          {                   
                           double deviation = iStdDevOnArray(rbci,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
                           double   average = iMAOnArray(rbci,0,VolatilityBandPeriod,0,VolatilityBandMAMode,i);
                                  bandUp[i] = average+VolatilityBandMultiplier*deviation;
                                bandDown[i] = average-VolatilityBandMultiplier*deviation;
                              bandMiddle[i] = average;
    
                           bullishDivergence[i] = EMPTY_VALUE;
                           bearishDivergence[i] = EMPTY_VALUE;
                                       trend[i] = trend[i+1];
 
                         if (rbci[i] > rbci[i+1]) trend[i]=  1;
                         if (rbci[i] < rbci[i+1]) trend[i]= -1;
                         
                         if (drawDivergences)
                         {
                             CatchBullishDivergence(i);
                             CatchBearishDivergence(i);
                         }           
                   }
                 manageAlerts();
                return(0);
                }                           

               //
               //
               //
               //
               //
   
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

                 for (i=limit;i>=0; i--)
                 {
                      int y = iBarShift(NULL,timeFrame,Time[i]);
                      rbci[i]              = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,colorBullishDivergence,colorBearishDivergence,shortName,0,y);
                      bandUp[i]            = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,colorBullishDivergence,colorBearishDivergence,shortName,1,y);
                      bandMiddle[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,colorBullishDivergence,colorBearishDivergence,shortName,2,y);
                      bandDown[i]          = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,colorBullishDivergence,colorBearishDivergence,shortName,3,y);
                      bullishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,colorBullishDivergence,colorBearishDivergence,shortName,4,y);
                      bearishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,colorBullishDivergence,colorBearishDivergence,shortName,5,y);
                      trend[i]             = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RbciSmoothLength,RbciSmoothPhase,RbciSmoothDouble,VolatilityBandPeriod,VolatilityBandMAMode,VolatilityBandMultiplier,drawDivergences,drawIndicatorTrendLines,drawPriceTrendLines,colorBullishDivergence,colorBearishDivergence,shortName,6,y);
                      
                      if (bullishDivergence[i]!= EMPTY_VALUE && bullishDivergence[i+1]!= EMPTY_VALUE) bullishDivergence[i+1] = EMPTY_VALUE;
                      if (bearishDivergence[i]!= EMPTY_VALUE && bearishDivergence[i+1]!= EMPTY_VALUE) bearishDivergence[i+1] = EMPTY_VALUE;
   
                      //
                      //
                      //
                      //
                      //
            
                      if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
                      datetime time = iTime(NULL,timeFrame,y);
                      for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                      for(int k = 1; k < n; k++)
                      
                      rbci[i+k]       = rbci[i]       + (rbci[i+n]       - rbci[i]      ) * k/n;
                      bandUp[i+k]     = bandUp[i]     + (bandUp[i+n]     - bandUp[i]    ) * k/n;
                      bandMiddle[i+k] = bandMiddle[i] + (bandMiddle[i+n] - bandMiddle[i]) * k/n;
                      bandDown[i+k]   = bandDown[i]   + (bandDown[i+n]   - bandDown[i]  ) * k/n;
   }
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+


double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]== 1) doAlert(whichBar,"sloping up");
         if (trend[whichBar]==-1) doAlert(whichBar,"sloping down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," rbci ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rbci "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define arrowsDisplacement 0.0001

void CatchBullishDivergence(int shift)
{
   shift++;
         bullishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(UniqueID+"l"+DoubleToStr(Time[shift],0));
            ObjectDelete(UniqueID+"l"+"os" + DoubleToStr(Time[shift],0));            
   if(!IsIndicatorLow(shift)) return;  

   //
   //
   //
   //
   //
      
   int currentLow = shift;
   int lastLow = GetIndicatorLastLow(shift+1);

   //
   //
   //
   //
   //
    
   if(rbci[currentLow] > rbci[lastLow] && Low[currentLow] < Low[lastLow])
   {
      bullishDivergence[currentLow] = rbci[currentLow] - arrowsDisplacement;
      if(drawPriceTrendLines == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],colorBullishDivergence,STYLE_SOLID);
      if(drawIndicatorTrendLines == true)
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],rbci[currentLow],rbci[lastLow],colorBullishDivergence,STYLE_SOLID);
   }
     
   //
   //
   //
   //
   //
        
   if(rbci[currentLow] < rbci[lastLow] && Low[currentLow] > Low[lastLow])
   {
      bullishDivergence[currentLow] = rbci[currentLow] - arrowsDisplacement;
      if(drawPriceTrendLines == true)
                 DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow], colorBullishDivergence, STYLE_DOT);
      if(drawIndicatorTrendLines == true)                            
                 DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],rbci[currentLow],rbci[lastLow], colorBullishDivergence, STYLE_DOT);
   }
}

//
//
//
//
//

void CatchBearishDivergence(int shift)
{
   shift++; 
         bearishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(UniqueID+"h"+DoubleToStr(Time[shift],0));
            ObjectDelete(UniqueID+"h"+"os" + DoubleToStr(Time[shift],0));            
   if(IsIndicatorPeak(shift) == false) return;
   int currentPeak = shift;
   int lastPeak = GetIndicatorLastPeak(shift+1);

   //
   //
   //
   //
   //
      
   if(rbci[currentPeak] < rbci[lastPeak] && High[currentPeak]>High[lastPeak])
   {
       bearishDivergence[currentPeak] = rbci[currentPeak] + arrowsDisplacement;
       if(drawPriceTrendLines == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],colorBearishDivergence,STYLE_SOLID);
       if(drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],rbci[currentPeak],rbci[lastPeak],colorBearishDivergence,STYLE_SOLID);
   }
   
   //
   //
   //
   //
   //

   if(rbci[currentPeak] > rbci[lastPeak] && High[currentPeak] < High[lastPeak])
   {
      bearishDivergence[currentPeak] = rbci[currentPeak] + arrowsDisplacement;
      if (drawPriceTrendLines == true)
               DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak], colorBearishDivergence, STYLE_DOT);
      if (drawIndicatorTrendLines == true)
               DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],rbci[currentPeak],rbci[lastPeak], colorBearishDivergence, STYLE_DOT);
   }   
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

bool IsIndicatorPeak(int shift)
{
   if(rbci[shift] >= rbci[shift+1] && rbci[shift] > rbci[shift+2] && rbci[shift] > rbci[shift-1])
         return(true);
   else  return(false);
}
bool IsIndicatorLow(int shift)
{
   if(rbci[shift] <= rbci[shift+1] && rbci[shift] < rbci[shift+2] && rbci[shift] < rbci[shift-1])
         return(true);
   else  return(false);
}
int GetIndicatorLastPeak(int shift)
{
   for(int i = shift+5; i < Bars; i++)
         if(rbci[i] >= rbci[i+1] && rbci[i] > rbci[i+2] && rbci[i] >= rbci[i-1] && rbci[i] > rbci[i-2])   return(i);
   return(-1);
}
int GetIndicatorLastLow(int shift)
{
   for(int i = shift+5; i < Bars; i++)
         if(rbci[i] <= rbci[i+1] && rbci[i] < rbci[i+2] && rbci[i] <= rbci[i-1] && rbci[i] < rbci[i-2]) return(i);
    return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   string label = UniqueID+first+"os"+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}
void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(shortName);
   if (indicatorWindow < 0) return;
   
   string label = UniqueID+first+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}